{
  unsigned char *pLine;
// This is included several times to create rendering function for each color depth

  nBmapY=nStartBmapY,pLine=pBurnDraw+bss.nTop*nBurnPitch+nStartPix;

  for (y=0; y<bss.nHeight; y++,nBmapY+=bss.nIncY, pLine+=nBurnPitch)
  {
    unsigned char *pPix,*pEnd; // Pointer to the output bitmap pixel/the end of the line
    int nBmapX,nBmapLine,nRealY;

    // Find which line we are on (output bitmap)
    nRealY=bss.nTop+y;

    nBmapLine=bss.nBase+(nBmapY>>9)*(bss.nWidth>>1); // Point to fractional sprite line

    // Clip to sprite data length
    if (nBmapLine<0) continue;
    if (nBmapLine>=nBsysSprDataLen) continue;

    pPix=pLine; // Find line on screen
    pEnd=pLine+nPixLen; // Find end

    for (nBmapX=nStartBmapX; pPix<pEnd;
         
#if BSS_DEPTH==4
         pPix+=4,
#elif BSS_DEPTH==3
         pPix+=3,
#elif BSS_DEPTH==2
         pPix+=2,
#else
         pPix++,
#endif
         
         nBmapX+=bss.nIncX)
    {
      int nPos,c;
      // Find this pixel out of the whole Bitmap memory block
      
      nPos=nBmapLine+(nBmapX>>10); 
      c=BsysSprData[nPos];  if ((nBmapX&0x200)==0) c>>=4;  c&=15;

      if (bss.nTrans&(1<<c)) continue; // Skip if transparent

      c=bss.pPal[c];
#if BSS_DEPTH==4
      *((unsigned int *)pPix)=c;
#elif BSS_DEPTH==3
      pPix[0]=(unsigned char) c;
      pPix[1]=(unsigned char)(c>>8);
      pPix[2]=(unsigned char)(c>>16);
#elif BSS_DEPTH==2
      *((unsigned short *)pPix)=(unsigned short)c;
#else
      *pPix=(unsigned char)c;
#endif

    }
  }
}