// Doze - Dave's optimized Z80 emulator
// Code maker -------------------------------------------------
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// dam.cpp
extern char szDamPc[];
extern char szDamCycles[];
int ot(char *szFormat,...);
void DamAlign();
void DamVarToReg();
void DamRegToVar();
int DamOpStart(unsigned int op);
int DamOpDone(int nCycles,int bDontEnd);

// dama.cpp
int DamaFlags(int bOverflow,char *szBits35);
int DamaOp(unsigned int op);

// damc.cpp
int DamcRotate(unsigned int op);
int DamcOpCb(unsigned int op);

// dame.cpp
int Dame_00xx_0001(unsigned int op);
int Dame_00xx_x011(unsigned int op);
int Dame_00xx_1001(unsigned int op);
int Dame_11xx_0x01(unsigned int op);
int DameExHL(unsigned int op);
int DameDirectMem16(unsigned int op);
int DameOpEd(unsigned int op);

// damf.cpp
int Damf_ED_101x_x00x(unsigned int op);
int Damf_ED_101x_x11x(unsigned int op);

// damj.cpp
extern int DamJump[0x700];
int DamJumpTab();

// damm.cpp
char *DamLoc8(int r,int nExt);
int DamGet8 (char *szTo  ,int r,int nExt);
int DamPut8 (char *szFrom,int r,int nExt);
char *DamLoc16(int r,int nExt);
int DamGet16(char *szTo  ,int r,int nExt);
int DamPut16(char *szFrom,int r,int nExt);
void DamIxIyOffset(int nRel);
void DamGetHL(int nExt);
int DamMacros();
int DamAddPc(int n);
int DamFetch(int nRel,int nSize);

// damo.cpp
int DamoOp(unsigned int op);

// damt.cpp
int DamTables();
